<?php
/* ======================================================
 # Display Date and Time for Joomla! - v2.4.0 (free version)
 # -------------------------------------------------------
 # For Joomla! CMS (v3.x)
 # Author: Web357 (Yiannis Christodoulou)
 # Copyright (©) 2014-2023 Web357. All rights reserved.
 # License: GNU/GPLv3, http://www.gnu.org/licenses/gpl-3.0.html
 # Website: https:/www.web357.com
 # Demo: https://demo.web357.com/joomla/date-time
 # Support: support@web357.com
 # Last modified: Saturday 06 April 2024, 02:13:21 AM
 ========================================================= */
 
defined('_JEXEC') or die;
use Joomla\CMS\Factory;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Uri\Uri;
use Joomla\CMS\Helper\ModuleHelper;

// Default Vars
$host = Uri::root();
$document = Factory::getDocument();

// Get Absolute path of Joomla
$absolute_path = getcwd();
$months = array( Text::_( 'MOD_DATETIME_JANUARY' ), Text::_( 'MOD_DATETIME_FEBRUARY' ), Text::_( 'MOD_DATETIME_MARCH' ), Text::_( 'MOD_DATETIME_APRIL' ), Text::_( 'MOD_DATETIME_MAY' ), Text::_( 'MOD_DATETIME_JUNE' ), Text::_( 'MOD_DATETIME_JULY' ), Text::_( 'MOD_DATETIME_AUGUST' ), Text::_( 'MOD_DATETIME_SEPTEMBER' ), Text::_( 'MOD_DATETIME_OCTOBER' ), Text::_( 'MOD_DATETIME_NOVEMBER' ), Text::_( 'MOD_DATETIME_DECEMBER' )); 
$days = array( Text::_( 'MOD_DATETIME_SUNDAY' ), Text::_( 'MOD_DATETIME_MONDAY' ), Text::_( 'MOD_DATETIME_TUESDAY' ), Text::_( 'MOD_DATETIME_WEDNESDAY' ), Text::_( 'MOD_DATETIME_THURSDAY' ), Text::_( 'MOD_DATETIME_FRIDAY' ), Text::_( 'MOD_DATETIME_SATURDAY' )); 
$server_now = time();

// Parameters
$layout = $params->get('layout', 'default');
$front_text = $params->get('front_text', '');
$end_text = $params->get('end_text', '');
$display_gmt = (int)$params->get('display_gmt', '1');
$display_minutes = (int)$params->get('display_minutes', '0');
$between_text_param = (string)$params->get('between_text', '');

// dateformat
$dateformat = $params->get('dateformat', '');

// dateformat js
$param_date_format = $params->get('date_format', 'custom');
$custom_date_format = $param_date_format === 'custom' ? $params->get('custom_date_format', 'dddd, MM MMMM YYYY') : $param_date_format;

$dateformat_separator = $params->get('dateformat_separator', '-');
$timeformat = $params->get('timeformat', '3');
$hour_system = (int)$params->get('hour_system', '12');
$show_leading_zero_for_hours = (bool) $params->get('show_leading_zero_for_hours', '1');
$show_leading_zeros_for_minutes = (bool) $params->get('show_leading_zeros_for_minutes', '1');
$display_pm_am = (int)$params->get('display_pm_am', '1');
$between_text = (!empty($between_text_param) && !empty($dateformat) && $timeformat != 4) ? $between_text_param.' ' : ''; // the text between date and time

$custom_time_format = '';

if ($hour_system == '12') {
	if ($show_leading_zero_for_hours && $show_leading_zeros_for_minutes) {
		$custom_time_format = 'hh:mm';
	} elseif ($show_leading_zero_for_hours && !$show_leading_zeros_for_minutes) {
		$custom_time_format = 'hh:m';
	} elseif (!$show_leading_zero_for_hours && $show_leading_zeros_for_minutes) {
		$custom_time_format = 'h:mm';
	} elseif (!$show_leading_zero_for_hours && !$show_leading_zeros_for_minutes) {
		$custom_time_format = 'h:m';
	}
} else {
	if ($show_leading_zero_for_hours && $show_leading_zeros_for_minutes) {
		$custom_time_format = 'HH:mm';
	} elseif ($show_leading_zero_for_hours && !$show_leading_zeros_for_minutes) {
		$custom_time_format = 'HH:m';
	} elseif (!$show_leading_zero_for_hours && $show_leading_zeros_for_minutes) {
		$custom_time_format = 'H:mm';
	} elseif (!$show_leading_zero_for_hours && !$show_leading_zeros_for_minutes) {
		$custom_time_format = 'H:m';
	}
}

if ($timeformat === '3') {
	$custom_time_format .= ':ss';
}

if ($display_pm_am) {
	$custom_time_format .= ' a';
}

// Display Date/Time in two rows
$datetime_in_two_rows = $params->get('datetime_in_two_rows', '0');

// CSS Styling
$custom_css = $params->get('custom_css');
if(!empty($custom_css) && Factory::getApplication()->input->get('option') !== 'com_gridbox')
{
	$document->addStyleDeclaration($custom_css, 'text/css');
}

// Get the Timezone from parameters
$config = Factory::getConfig();
$timezone = $params->get('timezone', '');
if ($timezone === 'gconfig_timezone') {
	$timezone = $config->get('offset');
}

$moduleId = $module->id;

require(ModuleHelper::getLayoutPath('mod_datetime', $layout));